/*
 * Copyright (C) 2011 by Apaq
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package dk.apaq.framework.repository;

import java.util.List;


/**
 * An abstract implementation of a <code>CrudListener</code> that has empty implementations
 * of all methods in  the interface. A class can extend this class and only implement the methods it need.
 */
public abstract class BaseRepositoryListener<BT, IDT> implements RepositoryListener<BT, IDT> {

    /**
     * {@inheritDoc}
     */
    @Override
    public void onBeforeEntityCreate(RepositoryEvent.WithEntity<BT, IDT> event) { /* EMPTY */ }

    /**
     * {@inheritDoc}
     */
    @Override
    public void onBeforeEntityDelete(RepositoryEvent.WithId<BT, IDT> event) { /* EMPTY */ }

    /**
     * {@inheritDoc}
     */
    @Override
    public void onBeforeEntityRead(RepositoryEvent.WithId<BT, IDT> event) { /* EMPTY */ }

    /**
     * {@inheritDoc}
     */
    @Override
    public void onBeforeEntityUpdate(RepositoryEvent.WithIdAndEntity<BT, IDT> event) { /* EMPTY */ }

    /**
     * {@inheritDoc}
     */
    @Override
    public void onEntityCreate(RepositoryEvent.WithIdAndEntity<BT, IDT> event) { /* EMPTY */ }

    /**
     * {@inheritDoc}
     */
    @Override
    public void onEntityDelete(RepositoryEvent.WithId<BT, IDT> event) { /* EMPTY */ }

    /**
     * {@inheritDoc}
     */
    @Override
    public void onEntityRead(RepositoryEvent.WithIdAndEntity<BT, IDT> event) { /* EMPTY */ }

    /**
     * {@inheritDoc}
     */
    @Override
    public void onEntityUpdate(RepositoryEvent.WithIdAndEntity<BT, IDT> event) { /* EMPTY */ }

   
    public void onBeforeList(RepositoryEvent.List<BT, IDT> event) { /* EMPTY */ }

    
    
    
    

}
