package dk.apaq.framework.repository;

import dk.apaq.framework.criteria.Criteria;
import java.util.List;

/**
 *
 * @author michael
 */
public interface Repository<BeanType, IdType> {
    
    IdType getIdFromEntity(BeanType entity);
    
    BeanType findOne(IdType id);
    BeanType findFirst(Criteria criteria);
    
    List<BeanType> findAll();
    List<BeanType> findAll(Criteria criteria);
    List<IdType> findAllIds();
    List<IdType> findAllIds(Criteria criteria);
    
    void deleteById(IdType id);
    void deleteAllById(List<IdType> ids);
    void deleteAllById(IdType ... ids);
    
    void delete(BeanType entity);
    void deleteAll(List<BeanType> entities);
    void deleteAll(BeanType ... entities);
    
    BeanType save(BeanType entity);
}
